package com.wizarpos.mdbtest;

import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;

import com.wizarpos.util.MDBUtils;

public class TransactionFragment extends Fragment implements View.OnClickListener {

	private DataSendListener dataSendListener;
	private final String TAG = "TransactionFragment";
	private Button btnSetBalance;
	private EditText etBalance;

	@Nullable
	@Override
	public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.fragment_transaction, container, false);
		btnSetBalance = view.findViewById(R.id.btn_set_balance);

		btnSetBalance.setOnClickListener(this);
		etBalance = view.findViewById(R.id.et_balance);
		return view;
	}

	@Override
	public void onClick(View v) {
		switch(v.getId()){
			case R.id.btn_set_balance:
				dataSendListener.onIntValueSent(MDBUtils.TYPE_BALANCE, getBalance());
				dataSendListener.onLogSent('d', TAG, "set balance succeed");
//				dataSendListener.onSetBalanceClicked();
				break;
			default:
				break;
		}

	}

	//default: 100
	public int getBalance(){
		int ret = -1;
		String sContent = etBalance.getText().toString();
		if(sContent.trim().isEmpty()){
			dataSendListener.onLogSent('d', TAG, "balance is empty, will be set to default: 100");
			return 100;
		}
		try{
			ret = Integer.parseInt(sContent);
		}catch(Exception e){
			dataSendListener.onLogSent('e', TAG, "balance value must be a number");
			return ret;
		}
		if(ret < 0 || ret > 65535){
			dataSendListener.onLogSent('e', TAG, "error: balance value range: 0~65535");
		}
		return ret;
	}

	@Override
	public void onAttach(Context context) {
		super.onAttach(context);
		try {
			dataSendListener = (DataSendListener) context;
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
}
